#include <cstdio>
#include <vector>
#include <map>

#define X first
#define Y second
#define PB push_back

using namespace std;

typedef pair < int, int > pii;

int n;
map < int, int > mp;

void solve() {
	mp.clear();
	vector < pii > v;	
	scanf("%d", &n);
	for(int i = 0;i < n;i++) {
		int x, y; scanf("%d%d", &x, &y);
		mp[x + y]++;
	}
	if(mp[0] == 0) {
		printf("YES\n");
		return;
	}
	for(auto tmp : mp) v.PB(tmp);
	for(;(int)v.size() > 1;) {
		pii zad = v.back(); v.pop_back();
		if(v.back().X == zad.X - 1)
			v.back().Y += zad.Y / 2;
		else {
			zad.Y /= 2; zad.X--;
			if(zad.Y) v.push_back(zad);
		}
	}
	if(v[0].Y >= 3) {
		printf("NO\n");
	} else {
		printf("YES\n");
	}
}

int main(){
	int T; scanf("%d", &T);
	for(;T--;) solve();
	return 0;
}
