#include <bits/stdc++.h>
#define x first
#define y second
using namespace std;
using ll=long long;
using pii=pair<int,int>;
using vi=vector<int>;
using vl=vector<ll>;
#define pb push_back
#define all(a) begin(a),end(a)

const int N=2510,MOD=1e9+7;
const char en='\n';
const ll LLINF=1ll<<60;

int dx[]={0,1,0,-1};
int dy[]={1,0,-1,0};

int n,m,dis[N],ins[N];
string h[N];
bool bio[N];
vi ch[N],ord;

void bfs(int x)
{
	memset(dis,63,sizeof(dis));
	queue<pii> q;
	q.push({x,0});
	vi bio(n*m);
	while (q.size())
	{
		int i=q.front().x;
		int d=q.front().y;
		q.pop();
		if (bio[i]) continue;
		bio[i]=1;
		dis[i]=d;
		for (auto a: ch[i]) q.push({a,d+1});
	}
}

void dfs1(int i)
{
	bio[i]=1;
	ord.pb(i);
	for (auto x: ch[i]) if (ins[x] && !bio[x]) dfs1(x);
}

int szun(vi a,vi b)
{
	for (auto x: b) a.pb(x);
	sort(all(a));
	a.erase(unique(all(a)),a.end());
	return a.size();
}

int main()
{
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cin>>n>>m;
	vi im1,im2;
	for (int i=0;i<n;++i)
	{
		cin>>h[i];
		for (int j=0;j<m;++j) if (h[i][j]!='X')
		{
			for (int k=0;k<4;++k)
			{
				int i1=i+dx[k],j1=j+dy[k];
				if (i1<0 || j1<0 || i1>=n || j1>=m || h[i1][j1]=='X') continue;
				ch[i*m+j].pb(i1*m+j1);
			}
		}
		for (int j=0;j<m;++j) if (h[i][j]=='*') im1.pb(i*m+j);
	}
	for (int i=0;i<n;++i)
	{
		cin>>h[i];
		for (int j=0;j<m;++j) if (h[i][j]=='*') im2.pb(i*m+j);
	}
	int ro=im2[0];
	bfs(ro);
	if (dis[im1[0]]>MOD)
	{
		cout<<"NO\n";
		exit(0);
	}
	
	vector<pii> pot;
	while (1)
	{
		int md=0;
		for (int i=1;i<(int)im1.size();++i) if (dis[im1[i]]<dis[im1[md]]) md=i;
		if (dis[im1[md]]==0) break;
		memset(ins,0,sizeof(ins));
		memset(bio,0,sizeof(bio));
		for (auto x: im1) ins[x]=1;
		ord.clear();
		int radi=im1[md];
		dfs1(radi);
		int mak=ord.back();
		/*cout<<"im1 =";
		for (auto x: im1) cout<<' '<<x;
		cout<<en;
		cout<<"ord =";
		for (auto x: ord) cout<<' '<<x;
		cout<<en;
		cout<<"mak = "<<mak<<endl;*/
		auto it=find(all(im1),mak);
		assert(it!=im1.end());
		assert(mak!=radi);
		im1.erase(find(all(im1),mak));
		bool nad=0;
		for (auto x: ch[radi]) if (dis[x]<dis[radi])
		{
			im1.pb(x);
			pot.pb({mak,x});
			nad=1;
			break;
		}
		assert(nad);
	}
	assert(find(all(im1),ro)!=im1.end());
	
	memset(ins,0,sizeof(ins));
	memset(bio,0,sizeof(bio));
	for (auto x: im1) ins[x]=1;
	ord.clear();
	dfs1(ro);
	vi or1=ord;
	
	memset(ins,0,sizeof(ins));
	memset(bio,0,sizeof(bio));
	for (auto x: im2) ins[x]=1;
	ord.clear();
	dfs1(ro);
	vi or2=ord;
	assert(or1.size()==or2.size());
	int sz=or1.size();
	int c1=sz,c2=1;
	while (c1>1)
	{
		--c1;
		if (szun(vi(or1.begin(),or1.begin()+c1),vi(or2.begin(),or2.begin()+c2))<sz)
		{
			while (szun(vi(or1.begin(),or1.begin()+c1),vi(or2.begin(),or2.begin()+c2))<sz) ++c2;
			if (or1[c1]!=or2[c2-1]) pot.pb({or1[c1],or2[c2-1]});
		}
	}
	cout<<"YES\n";
	cout<<pot.size()<<en;
	for (auto x: pot) cout<<x.x/m+1<<' '<<x.x%m+1<<' '<<x.y/m+1<<' '<<x.y%m+1<<en;
}
